from Globals import HTMLFile, HTML
from PortalContent import PortalContent
from Acquisition import Implicit

def addLink(self, id, title, remote_url, text, RESPONSE=None):
    """
    Add a Link
    """
    o=Link()
    o.id=id
    o.title=title
    o.text=text
    o.remote_url=remote_url
    o._parse()
    self._setObject(id,o)
    if RESPONSE is not None:
        RESPONSE.redirect(self.absolute_url()+'/portal_contents')
        
class Link(Implicit, PortalContent):
    """
    A Link
    """

    meta_type='Link'

    __ac_permissions__=(
        ('View', ('', 'index_html')),
        ('View management screens',('editForm',)),
        ('Change Links', ('edit',), ('Owner','Manager')),
        )

    index_html=HTMLFile('dtml/linkView', globals())

    editForm=HTMLFile('dtml/linkEdit',globals())

    def edit(self, title, remote_url, text, REQUEST=None):
        """
        Edit the Link
        """
        self.title=title
        self.text=text
        self.remote_url=remote_url
        self._parse()
        self.getPortal().notify_content(self, REQUEST.AUTHENTICATED_USER)
        if REQUEST is not None:
            return self.editForm(self, REQUEST,
                                 portal_status_message='Link changed.')

    _format_text=HTML("""<dtml-var text fmt="structured-text">""")

    def _parse(self):
        self.cooked_text=self._format_text(self) 

    def SearchableText(self):
        "text for indexing"
        return "%s %s" % (self.title, self.text)

    def Description(self):
        "description for indexing"
        return self.text

    def toolbox_actions(self):
        return (
            {'name':'View',
             'url': self.absolute_url() + '/index_html',
             'permissions':('View',),
             'category':'object',
             },  
            {'name':'Edit',
             'url': self.absolute_url() + '/editForm',
             'permissions': ('Change Links',),
             'category':'object',
             },
            {'name':'Set status',
             'url': self.absolute_url() + '/publish',
             'permissions': ('Request review', 'Publish portal content',
                            'Review portal content'),
             'category':'object',
             },
            
            )

from Products.PTKBase.register import registerPortalContent
registerPortalContent(Link,
                      constructors=(addLink,),
                      action='Wizards/Link',
                      icon="link.gif")
