from Globals import HTMLFile, HTML
from PortalContent import PortalContent
from Acquisition import Implicit

def addNewsItem(self, id, title, text, description, RESPONSE=None):
    """
    Add a NewsItem
    """
    o=NewsItem()
    o.id=id
    o.title=title
    o.text=text
    o.description = description
    o._parse()
    self._setObject(id,o)
    if RESPONSE is not None:
        RESPONSE.redirect(self.absolute_url()+'/portal_contents')

class NewsItem(Implicit, PortalContent):
    """
    A News Item
    """

    meta_type='News Item'

    __ac_permissions__=(
        ('View', ('', 'index_html')),
        ('View management screens',('editForm',)),
        ('Change News Items', ('edit',), ('Owner','Manager')),
        )

    index_html=HTMLFile('dtml/newsView',globals())

    editForm=HTMLFile('dtml/newsEdit',globals())

    def edit(self, title, text, description, REQUEST=None):
        """
        Edit the News Item
        """
        self.title=title
        self.text=text
        self.description=description
        self._parse()
        self.getPortal().notify_content(self, REQUEST.AUTHENTICATED_USER)
        if REQUEST is not None:
            return self.editForm(self, REQUEST,
                                 portal_status_message='News Item changed.')

    def _parse(self):
        self.cooked_text=self._format_text(self)     
        
    _format_text=HTML("""<dtml-var text fmt="structured-text">""")

    def SearchableText(self):
        "text for indexing"
        return "%s %s %s" % (self.title, self.description, self.text)

    def Description(self):
        "description for indexing"
        return self.description

    def toolbox_actions(self):
        "return portal toolbox management actions"
        return (
            {'name':'View',
             'url':  self.absolute_url() + '/index_html',
             'permissions':('View',),
             'category':'object',
             },       
            {'name':'Edit',
             'url':  self.absolute_url() + '/editForm',
             'permissions':('Change News Items',),
             'category':'object',
             },
            {'name':'Set status',
             'url':  self.absolute_url() + '/publish',
             'permissions': ('Request review', 'Publish portal content',
                            'Review portal content'),
             'category':'object',
             },
            
            )

from Products.PTKBase.register import registerPortalContent
registerPortalContent(NewsItem,
                      constructors=(addNewsItem,),
                      action='Wizards/NewsItem',
                      icon="newsitem.gif")
