from Globals import HTMLFile
import Acquisition

class Toolbox(Acquisition.Implicit):
    """
    Draws a toolbox on the portal UI
    """

    template=HTMLFile('dtml/toolbox',globals())

    def __call__(self, obj, REQUEST):
        """
        Display the toolbox in HTML
        """
        actions=[]
        filtered_actions={'user':[],
                          'object':[],
                          'global':[]
                          }
        user=REQUEST.AUTHENTICATED_USER
        if hasattr(obj.aq_base, 'toolbox_actions') and \
           hasattr(obj,'getPortal') and obj.getPortal() != obj:
            actions=actions+list(obj.toolbox_actions())
        if hasattr(obj.getPortal(), 'toolbox_actions'):
            actions=actions+list(obj.getPortal().toolbox_actions())
        if hasattr(user.aq_base, 'toolbox_actions'):
            actions=actions+list(user.toolbox_actions())
        for action in actions:
            if not action['permissions']:
                # This action requires no permissions
                filtered_actions[action['category']].append(action)
                continue
            for permission in action['permissions']:
                if user.has_permission(permission, obj):
                    filtered_actions[action['category']].append(action)
                    break

        user_name=user.getUserName()
        if user_name == 'Anonymous User':
            color='#FFDDDD'
            user_name='Guest'
        else:
            color='#DDDDFF'
                    
        return self.template(obj, REQUEST,
                             color=color,
                             user_name=user_name,
                             user_actions=filtered_actions['user'],
                             object_actions=filtered_actions['object'],
                             global_actions=filtered_actions['global'],
                             obj=obj
                             )
